image: docker:19

stages:
  - build
  - push
  
services:
  - docker:dind

before_script:
  - echo -n $MY_CR_PASSWORD | base64 -d | docker login -u $MY_CR_ID --password-stdin $MY_CR_REGISTRY

build:
  stage: build
  script:
    - docker pull $MY_CR_IMAGE:latest || true
    - docker build --pull --cache-from $MY_CR_IMAGE:latest --tag $MY_CR_IMAGE:$CI_COMMIT_SHA $CI_COMMIT_TAG/.
    - docker push $MY_CR_IMAGE:$CI_COMMIT_SHA
    - docker tag $MY_CR_IMAGE:$CI_COMMIT_SHA $MY_CR_IMAGE:latest
    - docker push $MY_CR_IMAGE:latest
  only:
    - tags
    
push tag:
  stage: push
  variables:
    GIT_STRATEGY: none
  script:
    - docker pull $MY_CR_IMAGE:$CI_COMMIT_SHA
    - docker tag $MY_CR_IMAGE:$CI_COMMIT_SHA $MY_CR_IMAGE:$CI_COMMIT_TAG
    - docker push $MY_CR_IMAGE:$CI_COMMIT_TAG
  only:
    - tags
